/*  
    I haven't coded for 20 years plus
    I am not familiar with Javascript -
    I am sorry for the messi code :)   
*/

// include the api
const { refObject, world, Color, Rotator, Vector } = require('@tabletop-playground/api');

// globals
actualPlayer = 1;   // green always makes the first move! works only WITHOUT VAR decl.!!
foundSalta = false; // works only WITHOUT VAR decl.!!
firstRun = true;
gameOver = false;

const testRun = false; // to be set manually
const hiColor = new Color(1, 1, 0, 1); // yellow is highlighting color
const loColor = new Color(1, 1, 1, 1); // white is the low color
const piecesPerColor = 8; // 15 pieces per color
const gameOverText = "*** G A M E  O V E R ***";

var normPos = function (wobblyPos) {
        
    return new Vector(Math.round(wobblyPos[0]), Math.round(wobblyPos[1]), wobblyPos[2]); // keep z untouched, or otherwise piece levitates
};

var prevPos = normPos(refObject.getPosition());
var oldPos = prevPos;
var blockPlayer = false;
var allObjects = world.getAllObjects();

sendMessageToOponent = function (thisPlayer, message) {

    let allPlayers = world.getAllPlayers();
    
    if (allPlayers.length > 1)
    {  // if there are two players
        let otherPlayer = allPlayers[1];
        if (thisPlayer != allPlayers[0]) otherPlayer = allPlayers[0];   
        otherPlayer.showMessage(message);
    }
    else
    {  // if you are playing against yourself
        thisPlayer.showMessage(message);
    }
};

// add a function to be called when
// this object gets grabbed by any player

refObject.onGrab.add(
    function (obj, player) {

        if (gameOver) {
            player.showMessage(gameOverText);
            blockPlayer = true; 
            return;
        }; 

        // test whether it is my turn

        let colorOfThisPiece = obj.getTemplateName()[2]; // actual players 'SteinFarbe'        

        if (testRun) console.log("Grabbed! TP slot:", player.getSlot()," Player ID:", actualPlayer);

        if ((world.getAllPlayers().length > 1) && (actualPlayer !=  (1 - 2*(player.getSlot() === 2)))) {

            if(firstRun) player.showMessage("Green Has First Move!"); else player.showMessage("Not Your Turn!");

            blockPlayer = true;
            
            return;
        };

        if (((actualPlayer ===  1) && (colorOfThisPiece === "r")) || 
            ((actualPlayer === -1) && (colorOfThisPiece === "g"))) {
 
            player.showMessage("Don't Move Your Oponent's Pieces!");

            blockPlayer = true;
                       
            return; 
        };

        // test if I there is s Salta requirement left over

        allObjects = world.getAllObjects();

        foundSalta = false;

        for (var i = 0; i < allObjects.length; i++) {  // we need to look a ALL pieces to find out

            var colorOfPiece = allObjects[i].getTemplateName()[2];
            var primeColor = allObjects[i].getPrimaryColor()[2];

            if ((colorOfPiece === colorOfThisPiece) && (primeColor === hiColor[2])) {// if the currently inspected piece is of the color of This piece
                                                                                     // and if it is marked for Salta, i.e. required to jump over
                foundSalta = true;
                break;
            };
        };

        let primeColorOfThis = obj.getPrimaryColor()[2]; // actual players 'SteinFarbe'        

        if ((foundSalta) && (primeColorOfThis !== hiColor[2])) { // if there is a requirement for salta but This piece is NOT marked for salta 
            player.showMessage("¡SALTA! One Piece Marked in Yellow Must Jump!");
            shuffleBack(obj);                   
            blockPlayer = true;
        };
    });
        

// add a function to be called when
// this object gets moved off the board

var shuffleBack = function (obj) {
    wrongMove.play(0,0.3,false);
    obj.setLinearVelocity(new Vector(0,0,0)); obj.setAngularVelocity(new Rotator(0,0,0));
    obj.setPosition(prevPos,0.6); // obj.setRotation(new Rotator(0,0,0),0);
    if (testRun) console.log(obj.getTemplateName()+" shuffled back to "+prevPos);
};

refObject.onHit.add(
    function (obj) {
        if (obj.getPosition() != prevPos) shuffleBack(obj);
    });


// add a function to be called to calculate
// the target position of a piece to finish the game

var tarCalc = function (obj) {
        
    var pieceName = obj.getTemplateName();
        
    var pieceEyes = parseInt(pieceName[0]); 
    var pieceType = pieceName[1];    
    var pieceColor = pieceName[2];
    var turnTable =  2 * (pieceColor == "g") - 1;

    var targetX = (10 * (pieceType == "s") + 14 * (pieceType == "p")) *turnTable;
    var targetY = (-22 + 8 * pieceEyes + 4 * (pieceType == "p")) * turnTable; 

    return {
        x: targetX,
        y: targetY,
    };
};


switchHand = function() { // used when disclosing a piece

    var lastPlayer = actualPlayer;
    actualPlayer = -1 * actualPlayer; // turn the table! 
    
    var justSwitched = true;

    if (actualPlayer > 0) 
    {
        greenHand.setPrimaryColor(greenColor); 
        redHand.setPrimaryColor(noColor); // renders it invisible
    }
    else
    {
        redHand.setPrimaryColor(redColor); 
        greenHand.setPrimaryColor(noColor); // renders it invisible
    };

    // foundSalta = false;
};


// add a function to be called when
// this object gets released by a player

refObject.onSnapped.add(
    function (obj, player) {
        
        if (blockPlayer) { // move back to previous location
            shuffleBack(obj);
            blockPlayer = false;
            return;
        }
   
        var LC =obj.getPosition();

        obj.setRotation(new Rotator(0,0,180)); // flip the piece!

        var nowPos = normPos(LC);
        var aimPos = new Vector(tarCalc(obj).x,tarCalc(obj).y,nowPos[2]); // copy z due to complete vector 

        if ((nowPos[0] === aimPos[0]) && (nowPos[1] === aimPos[1]))
        {  // this piece is where it aimed at
            obj.setRotation(new Rotator(0,0,0)); // flip the piece back to show its identity!
            obj.setRoughness(0.27); obj.setMetallic(1); // make it a bit shiny
            onTarget.play(0,0.3,false);
        };

        var xdist = Math.abs(LC[0] - prevPos[0]);
        var ydist = Math.abs(LC[1] - prevPos[1]);

        xdist = Math.round(xdist);
        ydist = Math.round(ydist);

        if ((xdist == 0) && (ydist === 0)) {  // piece was just lifted

            if (testRun) 
            {
                let nowPos = normPos(LC);
                let endPos = new Vector(tarCalc(obj).x, tarCalc(obj).y,LC[2]);

                console.log("--------------");
                console.log(obj.getTemplateName() + " is @ x = " + nowPos[0] + "  y = " + nowPos[1] + " z = "+ nowPos[2]);
                console.log("Target is x = " + endPos[0] + "  y = " + endPos[1]);
                // world.drawDebugLine(nowPos, endPos, new Color(0, 1, 1, 255), 2, 0.15);  // sending beam to target position
            };

            if (!foundSalta)
            {
                world.showPing(aimPos,new Color(actualPlayer < 0, actualPlayer > 0, 0, 255));
                obj.setRotation(new Rotator(0,0,0)); // flip the piece back to show its identity!
                switchHand(); // switch player
            };

            return; // no further testing needed
        }

        var oneStep = (xdist === ydist) && (xdist === 4); // was it moved only one field? 

        colorOfPiece = obj.getTemplateName()[2]; // steinfarbe
        var frwrd = ((LC[0] > prevPos[0]) === (colorOfPiece === "g")); // was the piece moved forward? 
        var from = LC; // new Vector(LC[0],LC[1],Math.abs(LC[2]));
        var to = from.add(new Vector(0, 0, -0.5)); // poking downwards

        if (testRun) world.drawDebugLine(from, to, new Color(1, 0, 0, 255), 4, 0.5);

        var stacked = world.lineTrace(from, to).length < 3; // was the piece stacked on top another piece? (if board & table are not poked) 

        var scan = world.lineTrace(prevPos, LC);
        var isOponent = (scan.length > 1) && ((scan[0].object.getTemplateName()[2]) != colorOfPiece) // is there an oponent ahead?
        var jumpedOver = frwrd && ((xdist === 8) && (ydist === 8)) && isOponent && foundSalta; // was the piece legally moved forward two fields?

        // console.log("stacked = "+stacked+" from "+from+" to "+to);

        if (testRun && jumpedOver) console.log(`jumped over ${scan[0].object.getTemplateName()}`);

        if (testRun) 
        {
            console.log("stacked= " + stacked + " oneStep= "+oneStep+" foundSalta= "+foundSalta+" jumpedOver= "+ jumpedOver);
            console.log("!stacked:" + (!stacked) + " && (oneStep && !foundSalta):" + (oneStep && !foundSalta) + " || jumpedOver:" + jumpedOver)
        };

        if (!stacked && ((oneStep && !foundSalta) || jumpedOver)) // legal move!
        {
            firstRun = false; // the first move by green is done

            oldPos = prevPos; // remember the old position for the records
 
            prevPos = normPos(LC); // remember the new position as legal

            gameOver = isGameOver(); // test on game over

            if (gameOver == false) { // it ain't over yet!

                 // search for a neighboring piece 
                if (findSaltaPieceAtPosition(obj)) {sendMessageToOponent(player,"¡S_A_L_T_A!"); saltaBell.play(0,0.2,false)};

                actualPlayer = -1 * actualPlayer; // turn the table!
                
                if (testRun) console.log("Switched! TP Slot =",player.getSlot()," Player ID =",actualPlayer);

                if (testRun) console.log("'" + obj.getTemplateName() + "' moved from " + oldPos[0] + "/" + oldPos[1] + " to " + prevPos[0] + "/" + prevPos[1]);

                if (actualPlayer > 0) {

                    greenHand.setPrimaryColor(new Color(0, 1, 0, 1)); 
                    redHand.setPrimaryColor(new Color(0, 0, 0, 0));} // renders it invisible

                else {

                    redHand.setPrimaryColor(new Color(1, 0, 0, 1)); 
                    greenHand.setPrimaryColor(new Color(0, 0, 0, 0));} // renders it invisible
            }
            else
            {
                sendMessageToOponent(player,gameOverText);

                redHand.setPrimaryColor(new Color(0, 0, 0, 0));   // renders it invisible
                greenHand.setPrimaryColor(new Color(0, 0, 0, 0)); // renders it invisible

                endOfGame.play(0,0.8,false);
            }
        }
        else 
        {
            player.showMessage("Unallowed Move!");
            shuffleBack(obj);
        };
    });


/*
 * determine whether the game is over
 */

var isGameOver = function () {

    var tada = false; // not over yet :)

    var greenComplete = 0; // no pieces in end position
    var redComplete = 0;
    var allRedPieces = new Array(piecesPerColor); 
    var allGreenPieces = new Array(piecesPerColor); 

    for (var n = 0; n < allObjects.length; n++) { // loop over all pieces

        var nowObj = allObjects[n];
        var nowObjCol = nowObj.getTemplateName()[2];

        if ((nowObjCol === "g") || (nowObjCol === "r"))
        {
            var nowPos = normPos(nowObj.getPosition());
            var aimPos = new Vector(tarCalc(nowObj).x,tarCalc(nowObj).y,nowPos[2]);

            nowObj.setRoughness(1); nowObj.setMetallic(0); // for now make it look "ordinary" 

            if ((nowPos[0] === aimPos[0]) && (nowPos[1] === aimPos[1])) {  // this piece is where it aimed at

                nowObj.setRoughness(0.27); nowObj.setMetallic(1); // make it a bit shiny

                let goldColor = new Color(1,1,0.67,1); // gold

                if (nowObjCol === "g") {allGreenPieces[greenComplete] = nowObj; greenComplete++;};
                if (greenComplete === piecesPerColor) { // all green pieces have reached their final position
                    for (var i = 0; i < piecesPerColor; i++) { // loop over all pieces of the winning color
                        allGreenPieces[i].setPrimaryColor(goldColor);
                        allGreenPieces[i].setMetallic(1);
                    };
                    tada = true; // yeah!!!
                };

                if (nowObjCol === "r") {allRedPieces[redComplete] = nowObj; redComplete++;};
                if (redComplete === piecesPerColor) { // all red pieces have reached their final position
                    for (var i = 0; i < piecesPerColor; i++) { // loop over all pieces of the winning color
                        allRedPieces[i].setPrimaryColor(goldColor);
                        allRedPieces[i].setMetallic(1);
                    };
                    tada = true; // yeah!!!
                };
            };
        };
    };

    if (testRun) console.log("green " + greenComplete + " @home, red " + redComplete + " @home" + " tada = " + tada);

    return(tada);
};


/*
 * Look for salta pieces at the given position, 
 * determine the jump condition and return it if existing
 */

var findSaltaPieceAtPosition = function (actualPiece) {

   var salta = false;

    if (testRun) console.log("---");

    for (var n = 0; n < allObjects.length; n++) { // loop over all pieces

        var nowObject = allObjects[n];
        var nowObjectName = nowObject.getTemplateName();

        const spikeStart = 1.8; // the probe we stick out to find other pieces
        const spikeStop = 5;

        if (!nowObjectName.includes("GaM")) { // as in "GaMe Board"; only pieces shall pass

            let refColor = actualPiece.getTemplateName()[2]; // the color of the piece that just has been moved
            var nowColor = nowObjectName[2]; // the color is defined by the 3rd char in the piece model name

            if (nowColor === refColor) // investigate only objects of the color of the refObject  
            {
                nowObject.setPrimaryColor(loColor); // reset salta marking probably set before

                var LC = nowObject.getPosition(); // remember the local position of the current piece

                var atEdge = (Math.abs(Math.round(LC[0])) == 14) || (Math.abs(Math.round(LC[1])) == 14); // are we at one of the edges of the board?

                // poking 45 degree to port
                var from = LC.add(new Vector(spikeStart * actualPlayer,  -spikeStart * actualPlayer, 0));
                var to = LC.add(new Vector(spikeStop * actualPlayer, -spikeStop * actualPlayer, 0));
                var matches = world.lineTrace(from, to); // the probe is sent 

                if (testRun) world.drawDebugLine(from, to, new Color(1, 0, 0, 255), 1, 0.1);

                if (matches.length > 0) // if any object was detected and it is an oponent 
                {
                    var prtObj = matches[0].object;  // there can only max one                
                    var prtColor = prtObj.getTemplateName()[2]; // 3rd char = color

                    if  (!atEdge && (prtColor != nowColor)) { // we are not at the edge of the baord and it is an oponent

                        if (testRun) console.log(nowObject.getTemplateName(),"found",prtObj.getTemplateName(),"on port side");

                        // poking 135 degree behind
                        from = LC.add(new Vector(-spikeStart * actualPlayer,  spikeStart * actualPlayer, 0));
                        to = LC.add(new Vector(-spikeStop * actualPlayer, spikeStop * actualPlayer, 0)); 
                        var objBehind = world.lineTrace(from, to);

                        if (testRun) world.drawDebugLine(from, to, new Color(1, 0, 0, 255), 1, 0.1);

                        if (objBehind.length === 0) {
                        // There is an empty field behind!  
                            if (testRun) console.log(prtObj.getTemplateName(),"von ",nowObject.getTemplateName()," markiert");
                            prtObj.setPrimaryColor(hiColor); 
                            salta = true; 
                        };
                    };
                };

                // poking 45 degree to starboard
                from = LC.add(new Vector(spikeStart * actualPlayer,  spikeStart * actualPlayer, 0));
                to = LC.add(new Vector(spikeStop * actualPlayer, spikeStop * actualPlayer, 0));
                matches = world.lineTrace(from, to); // the probe is sent 
            
                if (testRun) world.drawDebugLine(from, to, new Color(0, 1, 0, 255), 1, 0.1);

                if (matches.length > 0)   // if any object was detected
                {               
                    var stbObj = matches[0].object;
                    var stbColor = stbObj.getTemplateName()[2];  // 3rd char = color

                    if  (!atEdge && (stbColor != nowColor)) { // we are not at the edge of the board and it is an oponent

                        if (testRun) console.log(nowObject.getTemplateName(),"found",stbObj.getTemplateName(),"on port side");

                        // poking 225 degree behind
                        from = LC.add(new Vector(-spikeStart * actualPlayer,  -spikeStart * actualPlayer, 0));
                        to = LC.add(new Vector(-spikeStop * actualPlayer, -spikeStop * actualPlayer, 0)); 
                        objBehind = world.lineTrace(from, to);

                        if (testRun) world.drawDebugLine(from, to, new Color(0, 1, 0, 255), 1, 0.1);

                        if (objBehind.length === 0) // There is an empty field behind!  
                        {
                            if (testRun) console.log(stbObj.getTemplateName(),"von ",nowObject.getTemplateName()," markiert");
                            stbObj.setPrimaryColor(hiColor); 
                            salta = true;
                        };
                    };
                };
            };
        };
    };

    return salta;
}
